; EnumIsMenu by kero, 2008-11-14

.386
.model			flat,stdcall
option			casemap:none

; ml   /I\masm32\include ...
; link /libpath:\masm32\lib ...

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32

.data
frmt1   db "hmenu_%d_%10.10lu.log",0
frmt2   db 13,10
frmt3   db "%9.8lX",0
frmt4   db 13,10,13,10,"%9.8lX%4.2d%10.8lX   ""%s""   ""%s""   ""%s""",0
frmt5   db "%9.8lX%12.8lX%14.8lX   ""%s""        ""%s""",13,10,0
        
.data?  
count   dd ?
buffer  dd 20000 dup(?)
sbuffer dd 20000 dup(?)
len     dd ?
slen    dd ?
hwin    dd ?
hsmenu  dd ?

.code

AddData proc uses ebx edi esi hMenu:HMENU,lParam:LPARAM

  local bytes:DWORD
  local buf[1024]:BYTE, buf2[128]:BYTE, buf3[128]:BYTE, buf4[128]:BYTE
  
	invoke CreateFile,offset frmt1,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	cmp eax,INVALID_HANDLE_VALUE
	jz @ret
	mov ebx,eax
  invoke SetFilePointer,ebx,0,0,FILE_END
  inc count
	invoke GetMenuItemCount,hMenu
	mov edi,eax
  invoke GetMenuString,hMenu,0,addr buf2,127,MF_BYPOSITION
  .if lParam==0
	 invoke wsprintf,addr buf,offset frmt2,hMenu
	.elseif lParam==1
	 invoke wsprintf,addr buf,offset frmt3,hMenu
	.elseif lParam==2
	  .if hwin!=0
      invoke GetClassName,hwin,addr buf3,127
      invoke GetWindowText,hwin,addr buf4,127
	  .else
	    mov byte ptr [buf3],0
	    mov byte ptr [buf4],0
    .endif
	  invoke wsprintf,addr buf,offset frmt4,hMenu,edi,hwin,addr buf3,addr buf4,addr buf2
	.else ; lParam==3
    invoke GetClassName,hwin,addr buf3,127
    invoke GetWindowText,hwin,addr buf4,127
	  invoke wsprintf,addr buf,offset frmt5,hMenu,hsmenu,hwin,addr buf3,addr buf4
	.endif
	mov bytes,eax
	invoke WriteFile,ebx,addr buf,bytes,addr bytes,0
	invoke CloseHandle,ebx
@ret:
  ret
AddData endp

WindowFromMenu proc uses ebx hWnd:HWND,hMenu:HMENU
  local buf[MAX_PATH]:BYTE
  local bu1[128]:BYTE
  local bu2[128]:BYTE
  invoke GetWindowLong,hWnd,GWL_STYLE
  and eax,WS_CHILD
  test eax,eax
  jnz @@@
  invoke GetMenu,hWnd
;  and eax,0ffffh
  cmp eax,hMenu
  jz @f
  invoke GetSystemMenu,hWnd,0
;  and eax,0ffffh
  cmp eax,hMenu
  jnz @@@
  invoke MessageBox,0,offset frmt1,0,0
@@:
  mov eax,hWnd
  mov hwin,eax
  invoke AddData,hMenu,2
@@@:
  xor eax,eax
  inc eax
  ret
WindowFromMenu endp

EnumMenuWindows proc uses ebx hWnd:HWND,lParam:LPARAM

  invoke GetWindowLong,hWnd,GWL_STYLE
  and eax,WS_CHILD
  mov ebx,eax
  invoke GetSystemMenu,hWnd,0
  mov hsmenu,eax
  invoke GetMenu,hWnd
  .if ebx!=0                           ; !!
    xor eax,eax
    inc eax
  .endif
  .if (eax==0 || eax==1) && hsmenu==0  ; !!
    jmp @f
  .endif
  mov ecx,hWnd
  mov hwin,ecx
  invoke AddData,eax,3
@@:
  xor eax,eax
  inc eax
  ret
EnumMenuWindows endp

start:
  pushad
  invoke GetDesktopWindow
  invoke EnumChildWindows,eax,offset EnumMenuWindows,0
  xor ebx,ebx
@@:
  inc ebx
  cmp ebx,100000h
;	cmp ebx,10000h
;  cmp ebx,0
	jz @f
  invoke IsMenu,ebx
	test eax,eax
	jz @b
	invoke GetMenuItemCount,ebx
	mov edi,eax
  invoke AddData,ebx,0
  mov ecx,len
  mov edx,offset buffer
  mov dword ptr [edx+ecx],ebx
  add len,4
	.if edi!=0 && edi!=-1
    xor esi,esi
    .while esi<edi
      invoke GetSubMenu,ebx,esi
      and eax,0ffffh
      .if eax!=0
        mov ecx,slen
        mov edx,offset sbuffer
        mov dword ptr [edx+ecx],eax
        add slen,4
        invoke AddData,eax,1
      .endif
      inc esi
    .endw
  .endif
	jmp @b
@@:
  xor edi,edi
  .while edi<=len
    mov edx,offset buffer
    mov eax,dword ptr [edx+edi]
    xor esi,esi
    .while esi<=slen
      mov edx,offset sbuffer
      mov ecx,dword ptr [edx+esi]
      .if eax==ecx
        jmp @f
      .endif
      add esi,4
    .endw
    mov esi,eax
    mov hwin,0
    invoke GetDesktopWindow
    invoke EnumChildWindows,eax,offset WindowFromMenu,esi
    .if hwin==0
      invoke AddData,esi,2
    .endif
@@:
    add edi,4
  .endw
  popad
	invoke GetTickCount
	invoke wsprintf,offset buffer,offset frmt1,count,eax
	invoke MoveFile,offset frmt1,offset buffer
	invoke MessageBeep,0
	invoke ExitProcess,0
end start
