; MenuSpy v.2008-11-19

.386
.model flat,stdcall
option casemap:none

; ml   /I\masm32\include ...
; link /libpath:\masm32\lib ...

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib comctl32

GUITHREADINFO struct
  cbSize         DWORD ?
  flags          DWORD ?
  hwndActive     HWND  ?
  hwndFocus      HWND  ?
  hwndCapture    HWND  ?
  hwndMenuOwner  HWND  ?
  hwndMoveSize   HWND  ?
  hwndCaret      HWND  ?
  rcCaret        RECT <>
GUITHREADINFO ends

MENUBARINFO struct
  cbSize         DWORD ?
  rcBar          RECT <>
  hMenu          HMENU ?
  hwndMenu       HWND ?
  fBarFocused    BOOL ?
  fFocused       BOOL ?
MENUBARINFO ends

.const
 id            equ 100
;OBJID_CLIENT   equ 0FFFFFFFCh
;OBJID_MENU     equ 0FFFFFFFDh
;OBJID_SYSMENU  equ 0FFFFFFFFh

.data
; _app     db " MenuSpy    //    1  caret,   2  move,   4  menu,   8  sysmenu,   10h  popup",0
 _class   db "Edit",0
 _32768   db "#32768",0
 _32774   db "#32774",0
 _ft      db 13,10,13,10,13,10,13,10,13,10,13,10,13,10,13,10,13,10
          db " pos:        %d",13,10
          db " id:         %8.8lX / %lu",13,10
          db " text:       %s",13,10,13,10
          db " hmenu:      %8.8lX / %lu",13,10
          db " ismenu:     %d",13,10,13,10
          db " hsubmenu:   %8.8lX / %lu",13,10
          db " ismenu:     %d",13,10,13,10
          db " menustate:  %8.8lX",13,10,13,10          
          db " hwndowner:  %8.8lX",13,10
          db " class:      %s",13,10,13,10
          db " hwndmnown:  %8.8lX",13,10
          db " class:      %s",13,10,13,10
          db " hwndpoint:  %8.8lX",13,10
          db " class:      %s",13,10,13,10
          db " hsysmenu:   %8.8lX / %lu",0
;          db " size:       %d * %d    <%d>",0

 _logfont LOGFONT <-11,0,0,0,400,0,0,0,1,0,0,0,0,"Courier New">

.data?
 hinst dd ?
 mbi MENUBARINFO <>
 mii MENUITEMINFO <>
 guiti GUITHREADINFO <>
.code

;##########################################################################################

SubProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local buf0[512]:BYTE, buf1[512]:BYTE, buf2[64]:BYTE, buf3[64]:BYTE, buf4[64]:BYTE, buf5[64]:BYTE, val:DWORD, val2:DWORD, val3:DWORD
  local wdth:DWORD, hght:DWORD, retval:DWORD, pt:POINT, rt:RECT, hsysmenu:DWORD ; , guiti:GUITHREADINFO, mbi:MENUBARINFO, mii:MENUITEMINFO
  local p1:DWORD, p2:DWORD

  .if uMsg==WM_DESTROY
    invoke KillTimer,hWnd,id
    invoke PostQuitMessage,0
    xor eax,eax

  .elseif uMsg==WM_COMMAND && wParam==id+1 && lParam==0
    invoke PostMessage,hWnd,WM_CLOSE,0,0
    xor eax,eax

  .elseif uMsg==WM_TIMER
    xor eax,eax
    mov byte ptr [buf0],al
    mov byte ptr [buf1],al
    mov byte ptr [buf2],al
    mov byte ptr [buf3],al
    mov byte ptr [buf4],al
    mov byte ptr [buf5],al
    
    invoke DestroyCaret
    
    invoke GetCursorPos,addr pt
    
    invoke WindowFromPoint,pt.x,pt.y
    mov ebx,eax
    
    invoke GetSystemMenu,ebx,FALSE
;    and eax,0ffffh
    mov hsysmenu,eax
    
    invoke GetClassName,ebx,addr buf2,63
    
    invoke GetWindow,ebx,GW_OWNER
    mov val,eax
    invoke GetClassName,val,addr buf4,63
    
    invoke GetWindowThreadProcessId,ebx,0
    mov ecx,eax
    mov guiti.cbSize,sizeof GUITHREADINFO
    invoke GetGUIThreadInfo,ecx,addr guiti

    mov eax,guiti.hwndMenuOwner
    mov val2,eax
    invoke GetClassName,val2,addr buf5,63

    invoke GetMenu,ebx
;    and eax,0ffffh
    mov esi,eax

    .if esi!=0
      mov eax,ebx
    .else ; (esi==0)
      .if val2!=0
        invoke GetMenu,val2
;        and eax,0ffffh
        mov esi,eax
        invoke GetMenuItemCount,esi
        mov edi,eax
        .while edi!=0
          dec edi
          invoke GetMenuState,esi,edi,MF_BYPOSITION
          and al,80h
          .if al!=0
            invoke GetSubMenu,esi,edi
;            and eax,0ffffh
            mov esi,eax
            mov eax,ebx
            jmp @f
          .endif
        .endw
        invoke GetSystemMenu,val2,FALSE
;        and eax,0ffffh
        mov esi,eax
        mov eax,val2
      .else
      .endif
    .endif
@@:

;    push eax
;
;    mov mbi.cbSize,sizeof MENUBARINFO
;    invoke GetMenuBarInfo,ebx,\ ; esi,\ ; 
;      OBJID_MENU,\ ; OBJID_CLIENT,\ ; 
;      0,offset mbi
;    mov retval,eax
;    mov eax,offset mbi
;    mov ecx,dword ptr[eax+4]
;    mov edx,dword ptr[eax+12]
;    sub edx,ecx
;    mov wdth,edx
;      
;    mov ecx,dword ptr[eax+8]
;    mov edx,dword ptr[eax+16]
;    sub edx,ecx
;    mov hght,edx
;
;    pop eax

    invoke MenuItemFromPoint,eax,esi,pt.x,pt.y
    mov edi,eax

    invoke IsMenu,esi
    mov p1,eax

    invoke GetMenuState,esi,edi,MF_BYPOSITION
    mov val3,eax

    invoke GetSubMenu,esi,edi
;    and eax,0ffffh
    push eax

    invoke IsMenu,eax
    mov p2,eax

    invoke GetMenuString,esi,edi,addr buf3,63,MF_BYPOSITION
    invoke GetMenuItemID,esi,edi
    mov ecx,eax
;    and ecx,0ffffh
    pop edx
    invoke wsprintf,addr buf1,offset _ft,edi,ecx,ecx,addr buf3,esi,esi,p1,edx,edx,p2,val3,val,addr buf4,val2,addr buf5,ebx,addr buf2,hsysmenu,hsysmenu   ; ,wdth,hght,retval
    invoke GetWindowText,hWnd,addr buf0,511
    invoke lstrcmp,addr buf1,addr buf0
    .if eax!=0
      invoke SetWindowText,hWnd,addr buf1
    .endif
      
    xor eax,eax
;------------------------------------------------------------------------------------------    

;	  invoke GetMenuItemRect,hWnd,hMenu,ItemPos,addr rt


;    mov mbi.cbSize,sizeof MENUBARINFO
;    invoke GetMenuBarInfo,ebx,idObject,idItem,addr mbi  ; << idObject: OBJID_CLIENT (popup menu), OBJID_MENU (menu bar - GetMenu), OBJID_SYSMENU (- GetSystemMenu) >>
;    invoke GetMenuBarInfo,ebx,OBJID_CLIENT,0,addr mbi
;    invoke GetMenuBarInfo,ebx,OBJID_MENU,0,addr mbi
;    invoke GetMenuBarInfo,ebx,OBJID_SYSMENU,0,addr mbi

;      mov mii.cbSize,sizeof mii
;     mov mii.dwTypeData,0
;      mov mii.cch,0
            
;      mov mii.fMask,MIIM_STRING or MIIM_TYPE or MIIM_FTYPE
;      mov mii.fType,MFT_STRING
       
;      invoke GetMenuItemInfo,esi,edi,1,addr mii
;      inc mii.cch
      
;      mov mii.fMask,MIIM_STRING or MIIM_TYPE or MIIM_FTYPE or MIIM_SUBMENU or MIIM_DATA or MIIM_ID
;      mov mii.fType,MFT_STRING
      
;      mov byte ptr [bu],0
;      lea eax,bu
;      mov mii.dwTypeData,eax
;      invoke GetMenuItemInfo,esi,edi,1,addr mii
      
;    invoke GetWindowThreadProcessId,ebx,0
;    mov ecx,eax
;    mov guiti.cbSize,sizeof GUITHREADINFO
;    invoke GetGUIThreadInfo,ecx,addr guiti
;    mov edi,guiti.hwndMenuOwner

;  flags          DWORD ?
;  hwndActive     HWND  ?
;  hwndFocus      HWND  ?
;  hwndCapture    HWND  ?
;  hwndMenuOwner  HWND  ?
;  hwndMoveSize   HWND  ?
;  hwndCaret      HWND  ?

;    invoke ScreenToClient,edi,addr pt

;------------------------------------------------------------------------------------------    
  .else
@def:
    invoke GetWindowLong,hWnd,GWL_USERDATA
    invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
    .if uMsg==WM_NCHITTEST && eax==HTCLIENT
      mov eax,HTCAPTION
    .elseif uMsg==WM_NCLBUTTONDOWN && wParam==HTMENU
      invoke DefWindowProc,hWnd,WM_SYSCOMMAND,SC_SIZE+9,0
    .endif
  .endif
  ret
SubProc endp

;##########################################################################################

MessageLoop proc
  local msg:MSG
  .while TRUE
    invoke GetMessage,addr msg,0,0,0
    .break .if (!eax)
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
  .endw
  mov	eax,msg.wParam
  ret
MessageLoop endp

;##########################################################################################

start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke FindWindow,offset _32774,0
  push eax
  invoke LoadMenu,hinst,id
  pop edx
  invoke CreateWindowEx,WS_EX_CLIENTEDGE or WS_EX_TOPMOST,\
    offset _class,0,\
    WS_VISIBLE or WS_POPUP or WS_THICKFRAME or WS_SYSMENU or ES_WANTRETURN or ES_MULTILINE or ES_AUTOVSCROLL or ES_AUTOHSCROLL,\
    920,10,300,500,edx,eax,hinst,0
  push ebx
  mov ebx,eax
  invoke SetWindowLong,ebx,GWL_WNDPROC,offset SubProc
  invoke SetWindowLong,ebx,GWL_USERDATA,eax
  invoke CreateFontIndirect,offset _logfont
  push eax
  invoke SendMessage,ebx,WM_SETFONT,eax,1
  invoke SetTimer,ebx,id,100,0
  invoke MessageLoop
  call DeleteObject
  call ExitProcess
  invoke InitCommonControls
end start

;##########################################################################################

